-- 招财猫
Lua_FortuneCatWindow = class("Lua_FortuneCatWindow", Lua_FullSizeWindow);
function Lua_FortuneCatWindow:ctor(p)
	self:superCall("ctor", false, true, 3500, false, false, false);

	self.windowName = "Lua_FortuneCatWindow";
	self.skinName = "FortuneCatWindow_skin";
end

function Lua_FortuneCatWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardArr = Array();
	self.highRewardArr = Array();

	self.zuiGaoTxt:setEnable(false);

	self.descTxt.text = LanUtil.getValue(124203);
	self.touruTxt.text = LanUtil.getValue(124202);
	self.huodeTxt.text = LanUtil.getValue(124204);
	self.zuiGaoTxt.text = LanUtil.getValue(124216);
	self.conTxt.text = LanUtil.getValue(124215);

	self.closeBtn:addClickFuntion(self, self.hide);
	self.rulesIcon:addClickFuntion(self, self.onHelpImgClick);
	self.getBtn:addClickFuntion(self, self.onGetBtnClick);

	self:onUpdatePanelInfo();
	self:addLuaEvent("rFortuneCatInfo", self, self.onUpdatePanelInfo);
	self:addLuaEvent("rFortuneCatTouru", self, self.onTouruSuccess);
	self:addLuaEvent("MONEY_UPDATE", self, self.onMoneyUpdate);
	Lua_ProxyManager.getProxy("Lua_FortuneCatProxy"):sFortuneCatInfo();
end

function Lua_FortuneCatWindow:onHelpImgClick(go)
	local str = DataCenter.fortuneCatData.descContent;
	if str ~= nil and str ~= "" then
		Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, str);
	end
end

function Lua_FortuneCatWindow:onTouruSuccess(itemId)
	if itemId ~= nil then
		local str = "gui_cat_"..itemId;
		if self.touruEff == nil then
			self.touruEff = UICreate.createUIEffect(self.content, "/effects/scsEffects/"..str, str, 0, 0);
			self.touruEff:SetRenderQueue(self.winBg, 2, 2, true);
			self.touruEff:setSacle(400, 400, 400);
		else
			self.touruEff:setUrl("/effects/scsEffects/"..str, str);
		end
	end
end

function Lua_FortuneCatWindow:onUpdatePanelInfo()
	self.showInfo = DataCenter.fortuneCatData.curShowInfo;
	if self.showInfo == nil then -- 投入完毕
		self.conSpr:SetActive(false);
		self.touruSpr:SetActive(false);
		self.huodeSpr:SetActive(false);
		self.getSpr:SetActive(false);

		self.getBtn.clickScale = false;
		self.getBtn:setGray(true);

		self.descTxt.text = LanUtil.getValue(124206);
		self.emptyTxt.text = LanUtil.getValue(124207);
	else
		self.touruSpr:SetActive(true);
		self.huodeSpr:SetActive(true);
		self.getSpr:SetActive(true);

		self.getBtn.clickScale = true;
		self.getBtn:setGray(false);

		self.emptyTxt.text = "";

		self.costNum = self.showInfo.costNum;
		self.costType = self.showInfo.costType;

		self:setCostInfo();
		self:setRechargeInfo();
		self:setCostConstInfo();
	end
	-- 就算投入完毕也有活动剩余时间
	self:updateLeftTime(DataCenter.fortuneCatData.residueTime);
end

function Lua_FortuneCatWindow:onMoneyUpdate(o)
	if self.showInfo == nil then
		return;
	end
	self:setCostInfo();
end

-- 更新剩余时间
function Lua_FortuneCatWindow:updateLeftTime(num)
	if num == nil or num < 0 then
		num = 0;
	end
	num = math.floor(num);

	self.startTime = getTime();
	self.residueTime = num;
	self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(124201), TimeTransform.getInstance():transSeconds1(self.residueTime, true));
	if num > 0 then
		if self.bRegistTimer ~= true then
			self.bRegistTimer = true;
			Lua_CommonUtil.addTimer("updateFortuneCatTime", 1, self, self.updateFortuneCatTime);
		end
	else
		self:clearTimer();
	end
end

function Lua_FortuneCatWindow:updateFortuneCatTime()
	local num = self.residueTime - (getTime() - self.startTime);
	if num <= 0 then
		num = 0;
		self:clearTimer();
	end
	self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(124201), TimeTransform.getInstance():transSeconds1(num, true));
end

function Lua_FortuneCatWindow:clearTimer()
	if self.bRegistTimer == true then
		self.bRegistTimer = false;
		Lua_CommonUtil.removeTimer(self, self.updateFortuneCatTime);
	end
end

-- 更新档位
function Lua_FortuneCatWindow:setRechargeInfo()
	local fortuneCatData = DataCenter.fortuneCatData;
	if fortuneCatData.conRechargeTotal > 0 then
		local str = fortuneCatData.curRechargeTotal;
		if fortuneCatData.conRechargeTotal > fortuneCatData.curRechargeTotal then
			str = Lua_ColorDefine.colorStr(str, Lua_ColorDefine.RED_STR);
		else
			str = Lua_ColorDefine.colorStr(str, Lua_ColorDefine.GREEN_STR);
		end
		str = str .."/".. "[FFB319]" .. fortuneCatData.conRechargeTotal .. "[-]";
		self.conNum.text = LanUtil.formateStr(LanUtil.getValue(124211), str);
	end
	self.conSpr:SetActive(fortuneCatData.conRechargeTotal > 0);
end

-- 更新消耗
function Lua_FortuneCatWindow:setCostInfo()
	if self.costType == nil or self.costNum == nil then
		return;
	end

	-- 投入描述
	local str = tostring(self.costNum);
	if DataCenter.moneyData:isMoneyEnough(self.costType, self.costNum, false, false) then
		str = Lua_ColorDefine.colorStr(str, "00E125");
	else
		str = Lua_ColorDefine.colorStr(str, Lua_ColorDefine.RED_STR);
	end
	self.numTxt.text = str;
end

-- 更新不用时时变化的消耗
function Lua_FortuneCatWindow:setCostConstInfo()
	if self.costType == nil or self.costNum == nil then
		return;
	end

	local uiatlasName = Lua_MoneyData.getMoneyIconAtlas(self.costType);
	local spriteName = Lua_MoneyData.getIconSpByMoneyType(self.costType);
	self.moneyIcon:setAltas(uiatlasName, spriteName);
	self.touruIcon:setAltas(uiatlasName, spriteName);

	local str = tostring(self.costNum);
	self.touruNum.text = str;

	-- 获得描述
	str = "";
	local item;
	local startX = 0;
	local arr = self.showInfo.rewards;
	if arr ~= nil then
		local gainType;
		local count = 1;
		local len = arr:getSize();
		for i = 1, len do
			item = self.rewardArr[i];
			if item == nil then
				item = Lua_FortuneCatItem.new(self.huodeSpr);
				self.rewardArr:add(item);
			end
			item:setData(arr[i]);
			item:setLocation(40 + startX, 5.5);
			startX = startX + item:getWidth() + 39;

			local itemName = getConfig({"item", arr[i].gainType, "name"});
			if itemName ~= nil then
				if count == 1 then
					gainType = arr[i].gainType;
					str = itemName;
				else
					str = str..LanUtil.formateStr(LanUtil.getValue(124210), itemName);
				end
				count = count + 1;
			end
		end

		if gainType ~= nil then
			self.titleBg:setAltas("fortuneCat_altas", "ui_zcm_z_"..gainType);
			self.titleBg:resetSize();
		end

		count = self.rewardArr:getSize() - len;
		while (count > 0) do
			item = self.rewardArr:remove(len + count);
			item:dispose();
			item = nil;
			count = count - 1;
		end
	else
		local len = self.rewardArr:getSize();
		while (len > 0) do
			item = self.rewardArr:remove(len);
			item:dispose();
			item = nil;
			len = len - 1;
		end
		self.rewardArr:clear();
	end
	self.descTxt.text = LanUtil.formateStr(LanUtil.getValue(124203), str);

	-- 高档次奖励
	local highArr = self.showInfo.highRewards;
	if highArr ~= nil then
		local count = 1;
		local len = highArr:getSize();
		for i = 1, len do
			item = self.highRewardArr[i];
			if item == nil then
				item = Lua_FortuneCatItem.new(self.huodeSpr);
				self.highRewardArr:add(item);
			end
			item:setData(highArr[i]);
			item:setLocation(40 + startX, 5.5, 0);
			startX = startX + item:getWidth() + 39;
		end

		count = self.highRewardArr:getSize() - len;
		while (count > 0) do
			item = self.highRewardArr:remove(len + count);
			item:dispose();
			item = nil;
			count = count - 1;
		end
	else
		local len = self.highRewardArr:getSize();
		while (len > 0) do
			item = self.highRewardArr:remove(len);
			item:dispose();
			item = nil;
			len = len - 1;
		end
		self.highRewardArr:clear();
	end
end

function Lua_FortuneCatWindow:onGetBtnClick(go)
	if self.showInfo == nil then -- 投入完毕
		-- OperateAlert.show(LanUtil.getValue(124206));
		return;
	end

	if DataCenter.fortuneCatData.conRechargeTotal ~= nil and DataCenter.fortuneCatData.conRechargeTotal > 0 then
		if DataCenter.fortuneCatData.conRechargeTotal > DataCenter.fortuneCatData.curRechargeTotal then
			Lua_WindowUtil.openWin("Lua_TipsWindow", WinParam.ACTION_OPEN, {owner = self, des = LanUtil.getValue(124214), type = 1, subFun = self.onGotoRecharge});
			OperateAlert.show(LanUtil.getValue(124213));
			return;
		end
	end

	if DataCenter.fortuneCatData.residueTime <= 0 then
		OperateAlert.show(LanUtil.getValue(124208));
		return;
	end

	if self.costType == Lua_MoneyData.BIND_GOLD then
		local num = DataCenter.moneyData:getMoney(self.costType);
		if num >= self.costNum then
			Lua_ProxyManager.getProxy("Lua_FortuneCatProxy"):sFortuneCatTouru();
			return;
		elseif DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD_AND_BINDGOLD) >= self.costNum then
			Lua_WindowUtil.openWin("Lua_TipsWindow", WinParam.ACTION_OPEN, {owner = self, des = LanUtil.getValue(124209), type = 1, subFun = self.onSubCallback});
			return;
		end
	end

	if DataCenter.moneyData:isMoneyEnough(self.costType, self.costNum, true, true) then
		Lua_ProxyManager.getProxy("Lua_FortuneCatProxy"):sFortuneCatTouru();
	end
end

function Lua_FortuneCatWindow:onGotoRecharge()
	Lua_WindowUtil.openWin("Lua_ChongzhiWindow");
end

function Lua_FortuneCatWindow:onSubCallback(d)
	Lua_ProxyManager.getProxy("Lua_FortuneCatProxy"):sFortuneCatTouru();
end

function Lua_FortuneCatWindow:dispose()
	if self.rewardArr ~= nil then
		self.rewardArr:dispose();
		self.rewardArr:clear();
		self.rewardArr = nil;
	end
	if self.highRewardArr ~= nil then
		self.highRewardArr:dispose();
		self.highRewardArr:clear();
		self.highRewardArr = nil;
	end
	if self.touruEff ~= nil then
		self.touruEff:dispose();
		self.touruEff = nil;
	end
	self:clearTimer();

	self:superCall("dispose");
end





--------------------------------------------------





Lua_FortuneCatItem = class("Lua_FortuneCatItem", Lua_DisplayObject);
function Lua_FortuneCatItem:ctor(p)
	self:superCall("ctor", p, "FortuneCatItem_skin");
end

function Lua_FortuneCatItem:buildShowItem()
	self:superCall("buildShowItem");

	self.content.name = "Lua_FortuneCatItem";
	self.touruNum.text = "";
end

function Lua_FortuneCatItem:setData(obj)
	local uiatlasName = Lua_MoneyData.getMoneyIconAtlas(obj.gainType);
	local spriteName = Lua_MoneyData.getIconSpByMoneyType(obj.gainType);
	self.touruIcon:setAltas(uiatlasName, spriteName);

	self.touruNum.text = obj.gainNum;
end

function Lua_FortuneCatItem:getWidth()
	return self.touruNum.mainContent.transform.localPosition.x + self.touruNum.width;
end